// Copyright 1999-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniCyberCash/Server/demo-server.c,v 1.2 2000/01/19 23:36:27 kc Exp $

#include <stdio.h>
#include <errno.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>

#define LISTEN_PORT 5746
#define MAX_CONNECTIONS 20

void readLine(int socket, char *buffer, int length)
{
    do {
       if (read(socket, buffer, 1) < 1)
           break;
    } while(*buffer++ != '\n');
    *buffer = '\0';
}

int main(int argc, char *argv[])
{
    int i, listening, connection;
    int length, returnError = 0;
    struct sockaddr_in address;
    fd_set readSet, writeSet, exceptionSet;

    listening = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    address.sin_family = AF_INET;
    address.sin_addr.s_addr = htonl(INADDR_ANY);
    address.sin_port = htons(LISTEN_PORT);
    if (bind(listening, &address, sizeof(address)) == -1) {
        printf("couldn't bind\n");
        exit(1);
    }
    if (listen(listening, 1) == -1) {
        printf("couldn't listen\n");
        exit(1);
    }
    while(1) {
        printf("listening...\n");
        connection = accept(listening, &address, &length);

        while(1) {
            int length;
            char message[100];
            char parameters[10000];
            char *resultString;

            readLine(connection, message, 100);
            if (!strlen(message))
                break;
            message[strlen(message)-1] = '\0';
            readLine(connection, parameters, 10000);
            parameters[strlen(parameters)-1] = '\0';
            printf("read message: %s params: %s\n", message, parameters);

            if (returnError)
                resultString = "MStatus=Error&MErrMsg=DemoError\n";
            else
                resultString = "MStatus=Success&MErrMsg=Ok&merch-txn=1\n";
            returnError = !returnError;
            write(connection, resultString, strlen(resultString));
        }
        close(connection);
    }
}
